"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var c_elem_1 = tslib_1.__importDefault(require("./c-elem"));
var helper_1 = require("./helper");
var local_storage_1 = tslib_1.__importDefault(require("./local-storage"));
var VueCssTs = function VueCssTs() {
    return {
        beforeCreate: function beforeCreate() {
            var _this = this;
            helper_1.stylesToChildComponet(_this);
            var styles = _this.$options.style;
            /*
            * 拓展css-module 换肤实现
            */
            var theme = local_storage_1.default.get('system-theme');
            if (Array.isArray(_this.$options.themes) && _this.$options.themes.length > 0
                && theme && theme !== '') {
                var result = _this.$options.themes.filter(function (t) { return t.name === theme; });
                if (Array.isArray(result) && result.length > 0) {
                    styles = result[0].style;
                }
            }
            _this.original$createElement = _this.original$createElement || _this.$createElement;
            _this.original_c = _this.original_c || _this._c;
            _this.$createElement = c_elem_1.default.bind(_this, {
                createElement: _this.original$createElement,
                context: _this,
                styles: styles
            });
            _this._c = c_elem_1.default.bind(_this, {
                createElement: _this.original_c,
                context: _this,
                styles: styles
            });
        },
        /*
          *  1. 释放第三方插件中的bind及对象
        */
        destroyed: function () {
            var _this = this;
            _this._c = null;
            _this.original_c = null;
            _this.$parent = null;
            _this.original$createElement = null;
            _this.$createElement = null;
            _this.$options = null;
        }
    };
};
VueCssTs.install = function (_Vue) {
    _Vue.mixin(VueCssTs());
};
exports.default = VueCssTs;
//# sourceMappingURL=index.js.map