"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    /**
     * 添加或修改
     *
     * @param {*} key
     * @returns
     */
    set: function (key, data) {
        if (data !== null && (typeof data === 'object')) {
            data = JSON.stringify(data);
        }
        localStorage.setItem(key, data);
    },
    /**
     * get查询
     */
    get: function (key) {
        var val = localStorage.getItem(key);
        if (val === null || val === 'null') {
            return null;
        }
        else if (val === 'undefined') {
            return undefined;
        }
        else {
            try {
                return JSON.parse(val); // 解析成功说明是JSON
            }
            catch (e) {
                return val;
            }
        }
    },
    /**
     * 修改 key 对应对象 中的字段
     * 如果对象不存在则创建
     */
    modify: function (key, fields) {
        var obj = this.get(key);
        if (obj === null) {
            obj = {};
        }
        if (obj instanceof Object && fields) {
            for (var name_1 in fields) {
                if (name_1 !== null) {
                    obj[name_1] = fields[name_1];
                }
            }
            this.set(key, obj);
        }
    },
    /**
     * 删除
     */
    remove: function (key) {
        if (key instanceof Array) {
            for (var _i = 0, key_1 = key; _i < key_1.length; _i++) {
                var k = key_1[_i];
                if (k !== null) {
                    localStorage.removeItem(k);
                }
            }
        }
        else {
            localStorage.removeItem(key);
        }
    }
};
//# sourceMappingURL=local-storage.js.map